<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>EventDetector &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/custom.css?v=4ad39fc2" />

  
    <link rel="shortcut icon" href="../../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../../_static/jquery.js?v=5d32c60e"></script>
        <script src="../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../../_static/doctools.js?v=888ff710"></script>
        <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="Mapping of OpenSCENARIO Actions" href="scenario_actions.html" />
    <link rel="prev" title="Coordinate Systems" href="coordinate_systems.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../index.html" class="icon icon-home">
            openPASS
              <img src="../../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/30_configs_in_depth.html">Configs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/50_scenario_simulation.html">Simulator</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="../20_simulator_advanced.html">Simulator</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="agent_components.html">Agent Components</a></li>
<li class="toctree-l2"><a class="reference internal" href="coordinate_systems.html">Coordinate Systems</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="#">EventDetector</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#collisiondetector">CollisionDetector</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="scenario_actions.html">Mapping of OpenSCENARIO Actions</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulation.html">Simulation</a></li>
<li class="toctree-l2"><a class="reference internal" href="spawner_features.html">Spawner Features</a></li>
<li class="toctree-l2"><a class="reference internal" href="system_structure_and_parameterization_%28SSP%29.html">System Structure and Parameterization (SSP)</a></li>
<li class="toctree-l2"><a class="reference internal" href="world_osi.html">World_OSI</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../20_simulator_advanced.html">Simulator</a></li>
      <li class="breadcrumb-item active">EventDetector</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../_sources/advanced_topics/simulator/event_detector.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="eventdetector">
<span id="id1"></span><h1>EventDetector<a class="headerlink" href="#eventdetector" title="Link to this heading"></a></h1>
<p>EventDetectors are executed at the beginning of each timestep.
A detector uses its access to the world and the framework to detect specific events.
After detection, the event is usually forwarded to the EventNetwork.</p>
<p>There are multiple EventDetectors available, all of them sharing a common interface.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Each instance of an EventDetector can have its own cycle time.</p>
</div>
<section id="collisiondetector">
<span id="eventdetector-collisiondetector"></span><h2>CollisionDetector<a class="headerlink" href="#collisiondetector" title="Link to this heading"></a></h2>
<p>The CollisionDetector checks whether a collision has occurred.
Moving and stationary objects are taken into account.
Objects are considered as collided, if their two-dimensional bounding boxes intersect.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>The calculation of the bounding box itself considers a potential inclination by the roll angle of an object (projection onto the xy-plane).</p>
</div>
<p>In case of a collision, a CollisionEvent containing the participating object Ids is created.
This type of event is picked up by the CollisionManipulator, which updates the state of the collided objects accordingly.</p>
<p>The geometric parameters of the crash configuration in terms of collision angles are determined according to Wagstrom et. al. (<a class="reference external" href="https://www-esv.nhtsa.dot.gov/Proceedings/26/26ESV-000177.pdf">https://www-esv.nhtsa.dot.gov/Proceedings/26/26ESV-000177.pdf</a>). In addition, collision velocities are stored.</p>
<figure class="align-default">
<img alt="../../_images/crash_config.svg" src="../../_images/crash_config.svg" /></figure>
<p>Furthermore, the CollisionDetector contains an impact evaluation which estimates based on momentum the changes in velocities due to the collision, considering vehicle mass ratio and initial crash configuration, e.h. <cite>VelocityChange</cite>. The impact model behind these calculations was developed and tested with full-overlap vehicle-to-vehicle collisions.</p>
<p>The concept was described in detail at ESAR 2016 in Kolk et. al. (<a class="reference external" href="https://bast.opus.hbz-nrw.de/opus45-bast/frontdoor/deliver/index/docId/1825/file/F117_21.pdf">https://bast.opus.hbz-nrw.de/opus45-bast/frontdoor/deliver/index/docId/1825/file/F117_21.pdf</a>).</p>
<p>The parameters stored for each collision are listed in detail in the table below.</p>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Parameter</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>CollisionVelocity</p></td>
<td><p>velocity of host prior to the collision</p></td>
</tr>
<tr class="row-odd"><td><p>CollisionWithAgent</p></td>
<td><p>true (1) / false (0) if collision occured with another agent</p></td>
</tr>
<tr class="row-even"><td><p>HCPA</p></td>
<td><p>host collision point angle in degree</p></td>
</tr>
<tr class="row-odd"><td><p>HCPAo</p></td>
<td><p>normalized HCPA</p></td>
</tr>
<tr class="row-even"><td><p>OCPA</p></td>
<td><p>opponent collision point angle</p></td>
</tr>
<tr class="row-odd"><td><p>OCPAo</p></td>
<td><p>normalized OCPA</p></td>
</tr>
<tr class="row-even"><td><p>OYA</p></td>
<td><p>opponent yaw angle</p></td>
</tr>
<tr class="row-odd"><td><p>OpponentCollisionVelocity</p></td>
<td><p>velocity of opponent prior to the collision</p></td>
</tr>
<tr class="row-even"><td><p>OpponentPointOfContactLocalX</p></td>
<td><p>X-coordinate of opponent point of contact in local coordinate system</p></td>
</tr>
<tr class="row-odd"><td><p>OpponentPointOfContactLocalY</p></td>
<td><p>Y-coordinate of opponent point of contact in local coordinate system</p></td>
</tr>
<tr class="row-even"><td><p>OpponentVelocity</p></td>
<td><p>velocity of opponent after the collision</p></td>
</tr>
<tr class="row-odd"><td><p>OpponentVelocityChange</p></td>
<td><p>velocity change of opponent due to collision</p></td>
</tr>
<tr class="row-even"><td><p>OpponentVelocityDirection</p></td>
<td><p>velocity direction</p></td>
</tr>
<tr class="row-odd"><td><p>OpponentYawVelocity</p></td>
<td><p>opponent yaw velocity</p></td>
</tr>
<tr class="row-even"><td><p>PointOfContactLocalX</p></td>
<td><p>X-coordinate of  point of contact in local coordinate system</p></td>
</tr>
<tr class="row-odd"><td><p>PointOfContactLocalY</p></td>
<td><p>Y-coordinate of opponent point of contact in local coordinate system</p></td>
</tr>
<tr class="row-even"><td><p>Velocity</p></td>
<td><p>velocity of host after the collision</p></td>
</tr>
<tr class="row-odd"><td><p>VelocityChange</p></td>
<td><p>velocity change of host due to collision</p></td>
</tr>
</tbody>
</table>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Both geometric interpretation and impact calculation only work for collisions between two car agents. A more general application is work in progress.</p>
</div>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="coordinate_systems.html" class="btn btn-neutral float-left" title="Coordinate Systems" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="scenario_actions.html" class="btn btn-neutral float-right" title="Mapping of OpenSCENARIO Actions" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>